#ifndef __EVENTSCUBTILE_H
#define __EVENTSCUBTILE_H


#include <vector>
#include "tact.H"

#include "event.H"


/**
 * Le type Event : un pointeur de fonction avec un paramèter InfoEvent
 */
// typedef void (*Event)(InfoEvent I);

class EventsCubtile{

private:
	ID_FACE idf;

	// Les Evenements à appeler
	std::vector<Event> Motion;
	std::vector<Event> Appear;
	std::vector<Event> Disappear;

	// Les Actions en attente d'être lancées
	std::vector<InfoEvent> bufferMotion;
	std::vector<InfoEvent> bufferAppear;
	std::vector<InfoEvent> bufferDisappear;

public:


	// Ajoute une fonction d'évenements
	void addEventMotion(Event  E);
	void addEventAppear(Event  E);
	void addEventDisappear(Event  E);


	// Appel directement un évenement
	void callEventMotion(InfoEvent  I);
	void callEventAppear(InfoEvent  I);
	void callEventDisappear(InfoEvent  I);

	// Stocke un évenement à signaler plus tard
	void storeEventMotion(InfoEvent  I);
	void storeEventAppear(InfoEvent  I);
	void storeEventDisappear(InfoEvent  I);

	// Appel et vide les évenements stockés
	void callBufferMotion();
	void callBufferAppear();
	void callBufferDisappear();

	// Affiche des informations sur l'etat du gestionnaire d'évenemetns
	void printStackEvents();
};

#endif
