#ifndef __GLTRANSFO_H
#define __GLTRANSFO_H

#include "transfo.H"

class glTransfo{
private:

	Transfo bas;
	Transfo haut;
	Transfo gauche;
	Transfo droite;

	SourceVideo2 * video;
	Matrx frame;


	// constants
	const int SCREEN_WIDTH;
	const int SCREEN_HEIGHT;
	const int CHANNEL_COUNT;
	const int DATA_SIZE;
	const GLenum PIXEL_FORMAT;

	// Image transformée
	Matrx im_transfo;

	// Nom de la texture
	GLuint Nom;


	// Les identifiants des deux VBO
	GLuint vboIdTex;
	GLuint vboIdPos;

	// Les tableaux pour l'upload des VBO
	GLfloat* coordTex;
	GLfloat* coordPos;

	//Comment est discrétisée l'image pour la transformation 
	int discretisation;

	//4 faces, deux coordonnées, et GL quads (donc 4)...
	int nbr_element_tex;

	// Meme chose, mais il y a trois coordonnées cette fois
	int nbr_element_pos;

	/**
	 * @brief créé  les Vertex Buffer Object
	 */
	void initVBO();

	/**
	 * @brief utilisé par initVBO
	 */
	void preRemplirVBO();

	/**
	 * @brief calcul la transformation en utilisant les VBO
	 */
	void drawVBO();

	/**
	 * @brief initialise les coordonnées des transformations
	 */
	void initMap(int precision);

	/**
	 * @brief Initialise la partie GLUT, notamment le contexte opengl
	 */
	int initGLUT(int argc, char **argv);

	/**
	 * @brief Initialise la partie GL
	 */
	void initGL();

	/**
	 * @brief paramètre les lumière de manière acceptable
	 */
	void initLights();


public:

	/**
	 * @brief initialise la transformation
	 */
	void init(int argc, char * argv[], SourceVideo2 * vid);

	glTransfo();

	void displayCBO();


	void getNext(Matrx & frm, Matrx & image);

	// Désalouer proprement les allocations dynamiques
	~glTransfo();

};


#endif
