#include <cassert>

//calcule la moyenne de la valeur des pixels situés à distance de centre
template<typename T>
double Matrx::moyennePxDisque(cv::Point2d centre, double distance, int nbr_echantillons){
	double step = 2*PI/nbr_echantillons;
	double angle = 1.2321;
	double coordx, coordy;

	double somme = 0;

	assert(isContinuous());

	for(int i=0; i<nbr_echantillons; i++){
		coordx = distance * cos(angle);
		coordy = distance * sin(angle);

		somme += getSubPx<T>(coordy + centre.y, coordx + centre.x);
		angle += step;
	}
	return somme/nbr_echantillons;
}



// Implémentation plus rapide que l'implémentation rapide
template <typename T>
double moyenneEcartsCarres(Matrx& img, Matrx& sub_img, cv::Point2d position){


	int x1 = floor(position.x);
	int y1 = floor(position.y);

	// Le décalage par rapport au centre
	double decalx = sub_img.cols/2.;
	double decaly = sub_img.rows/2.;

	// Les pointeurs sur les tableaux
	T* ptr_imagehg;
	T* ptr_imagehd;
	T* ptr_imagebg;
	T* ptr_imagebd;

	//Les coefficients : les aires de chaques sous pixels
	double coefhg = (x1+1-position.x) * (y1+1-position.y);
	double coefhd = (position.x-x1) * (y1+1-position.y);
	double coefbg = (x1+1-position.x) * (position.y-y1);
	double coefbd = (position.x-x1) * (position.y-y1);

	//Pointeur pour parcourir la sous-image
	T* ptr_sub_image = sub_img.data;

	//positions de départs en dans la grande image (en haut à gauche)
	int pos_depart_x = floor(position.x - decalx);// La position du coin superieur droit
	int pos_depart_y = floor(position.y - decaly);

	double somme = 0;

	//On parcous sur les lignes
	for(int i = 0; i<sub_img.rows; i++){

		// Maj des pointeurs sur la grande image
		ptr_imagehg = &(img.data[(i+pos_depart_y)*sub_img.cols+pos_depart_x]);
		ptr_imagehd = &(img.data[(i+pos_depart_y)*sub_img.cols+pos_depart_x+1]);
		ptr_imagebg = &(img.data[(i+pos_depart_y+1)*sub_img.cols+pos_depart_x]);
		ptr_imagebd = &(img.data[(i+pos_depart_y+1)*sub_img.cols+pos_depart_x+1]);

		// parcours sur les colonnes
		for(int j = 0; j<sub_img.cols; j++){

			// le sous-pixel
			double subpx = 
				coefhg * *ptr_imagehg +
				coefhd * *ptr_imagehd +
				coefbd * *ptr_imagebd +
				coefbg * *ptr_imagebg;
				
			// L'écart quadratique
			double diff = subpx - *ptr_sub_image;
			somme += diff*diff;

			// Maj des pointeurs
			++ptr_imagehg;		
			++ptr_imagehd;
			++ptr_imagebg;
			++ptr_imagebd;

			++ptr_sub_image;
		}
	}

	// Retourne la moyenne
	return somme/(sub_img.rows * sub_img.cols); 
}


