#include <iostream>
#include <fstream>
#include <string>

#include <vector>

#include <RInside.h>

#include "parser.h"
using namespace std;

vector<Point> parse(string filename){
	FILE* fichier;
	fichier = fopen(filename.c_str(),"r");
	int retval = 1;
	double d;
	vector<Point> vec;
	Point p;
	if ( fichier != NULL){
		while(retval){
			if ((retval=fscanf(fichier,"%lg",&d)!=EOF) && retval) {
				p.x = d;
			} else {
				break;
				std::cout << "erreur fichier erroné" << std::endl;
			}
			if ((retval=fscanf(fichier,"%lg",&d)!=EOF) && retval) {
				p.y = d;
			} else {
				std::cout << "erreur fichier erroné" << std::endl;
				break;
			}
			vec.push_back(p);
		}
	} else {
		std::cout << "Erreur à l'ouverture" << std::endl;
	}
	fclose(fichier);
	return vec;
}


int main(int argc, char *argv[])
{
		// create a vector
	vector<Point> p;
	string name = argv[1];
	p = parse(name);

	vector<double> vx,vy;
	for ( unsigned i = 0 ; i < p.size(); ++i){
		vx.push_back(p[i].x);
		vy.push_back(p[i].y);
	}	

	// create an embedded R instance
	RInside R(argc, argv);

	// create a variable points contening the vector points	
	R.assign(vx,"x");
	R.assign(vy,"y");

	// we can fisrt test if our data is gaussien with a shapiro test
	R.parseEval("t<-shapiro.test(x)");
	R.parseEval("pvalue=t$p.value");
	double pvalue = R["pvalue"];

	cout << " la pvalue est de " << pvalue << " \n on considère qu'un échantilon est gaussien si pvalue < 0.1 " << endl;

	double var;
	// compute the var of the vector
	R.parseEval("var<-var(points)");
	var=R["var"];

	double moy;
	// compute the mean of the vector
	R.parseEval("moy<-mean(points)");
	moy=R["moy"];

	std::cout << "Il y a 99% de chance que le point se trouve dans l'intervalle " << moy - 3*var << " et " << moy + 3*var << std::endl;

	// generate a vector of normal law
	R.parseEval("size<-length(points)");
	R.parseEval("g<-rnorm(size,moy,var)");

	R.parseEval("x<-c(1:size)");
	// we can display the data
	R.parseEval("pdf('gaussienne.pdf')");
	R.parseEval("plot(points~x");
//	R.parseEval("lines(g)");
	R.parseEval("dev.off()");

}
