#ifndef __TRANSFO_H
#define __TRANSFO_H

#ifdef __APPLE__
#include <GLUT/glut.h>
#else
#include <GL/freeglut.h>
#endif


#ifdef __APPLE__
#include <OpenGL/gl.h>
#include <OpenGL/glu.h>
#else
#include <GL/gl.h>
#endif

#include "util.H"
#include "sourceVideo.H"
#include "transformation.H"

/**
 * @class Transfo
 * @brief Classe chargée de remplir les vertex buffer Object pour les transformations d'une face
 */

class Transfo{

public:
	// La référence de la face
	ID_FACE id;

	// les coordonnées respectivement et pour la face du bas :
	coordPix A; // En bas à gauche
	coordPix B; // EN bas à droite
	coordPix C; // En haut à droite
	coordPix D; // En haut à gauche
	coordPix E; // En bas au milieu
	coordPix F; // En haut au milieu

	int tailleMap; // taille du mapping (discrétisation)
	coordPix ** Map; // mapping de l'image déformée (trapèze)

	coordPix * ListeCentres;
	double * ListeRayons;

	// Initialise les tableaux
	void setMap(int nbDiscretisation);

	//Enregistre les coordonnées dans la class
	void setCoord(double xA, double yA,
	              double xB, double yB,
	              double xC, double yC,
	              double xD, double yD,
	              double xE, double yE,
	              double xF, double yF,
	              SourceVideo2* video,
	              ID_FACE idf);

	// rempli les tableaux
	void mapping();

	void GenListeCentreRayon();


	//La transformation avec une boucle for classique et des glVertex3f classique

	void draw(double divl, double divh, double decx, double decy);

	//remplissage des vertex buffer Object pour des GL_QUADS
	void remplir(double divl, double divh, double decx, double decy, GLfloat*& ptrTex,GLfloat*& ptrPos);

	//Meme chose pour des GL_TRIANGLES
	void remplirTriangles(double divl, double divh, double decx, double decy, GLfloat*& ptrTex, GLfloat*& ptrPos);

};

#endif
