#ifndef __TRANSFORMATION_H
#define __TRANSFORMATION_H

#include "util.H"

double distance(coordPix p1, coordPix p2);

/* Renvoie le centre du cercle passant par P1,P2,P3 */
coordPix cercleTroisPts(coordPix P1, coordPix P2, coordPix P3) ;


/* Renvoie le coefficient directeur et l'ordonnée à l'origine de la droite
 * passant par les points P1 et P2 */
coordPix droiteDeuxPts(coordPix P1, coordPix P2);


/* Renvoie le point d'intersection des droites d1 et d2 (non parallèles) */
coordPix interDeuxDroites(coordPix d1, coordPix d2);

/* Fonction quadratique déterminée empiriquement représentant la variation
 * de la dimension d'un carré sur l'image déformée */
double variationRayon(double x);

/* Interpole le rayon entre r1 et r2 en tenant compte de la fonction sus-citée */
double interpolRayonQuad(double r1, double r2, double alpha);

/* Interpolation précédente ou linéaire suivant la méthode */
double interpolRayon(double r1, double r2, double alpha, int methode);

double fctRepartition(double x, int tailleMap);

void GenRepartition(coordPix P1, coordPix P2, coordPix * L, int tailleMap);


/* Calcul un point du maillage, résultant de l'intersection d'un cercle (obtenu
 * par interpolation linéaire de coefficient alpha des cercles c1 et c2)
 * et d'une droite passant par G inclinée d'un angle theta par rapport 
 * à la droite (AD) passant également par G et de coefficient directeur a */
coordPix calculNoeud(double alpha, double theta, 
					 double a, coordPix G,
					 coordPix c1, coordPix c2, 
                     double r1, double r2, int tailleMap,
					 coordPix * Lcentre, double * Lrayon);


#endif
